from math import pi, sin

import attr

from prism_agents.agents.forecast.forecasters.fundamentalist.fund_forecaster import (
    SimpleFundamentalState,
)


@attr.s(frozen=True, auto_attribs=True)
class Sinusoid(SimpleFundamentalState):
    """
    Deterministic, sinusoidal value process
    """

    amplitude: float
    frequency: float
    center: float
    phase: float

    def _compute(self) -> float:
        return self.amplitude * sin(2 * pi * self.frequency * self.step + self.phase) + self.center
