from abc import ABC, abstractmethod
from typing import Optional

import attr

from prism_agents.agents.forecast.forecasters.fundamentalist.fund_forecaster import FundamentalState


@attr.s(frozen=True, auto_attribs=True)
class ValueState(FundamentalState[Optional[float]], ABC):
    """
    Base class for the state of a fundamental process
    that keeps track of the current value of the process
    """

    @abstractmethod
    def get_value(self) -> Optional[float]:
        pass
