from abc import abstractmethod
from typing import Dict, Mapping

from torch import nn


class SerializableBaseModel(nn.Module):
    def get_constructor_inputs(self) -> Dict:
        pass

    @classmethod
    @abstractmethod
    def from_dict(cls, inputs: Mapping):
        pass
