from pathlib import Path
from typing import Mapping

import matplotlib.figure
import plotly


def save_plotly(fig: plotly.graph_objs.Figure, loc: Path):
    fig.write_html(str(loc), include_plotlyjs="cdn")


def save_plots_to_dir(plots: Mapping[str, plotly.graph_objs.Figure], folder: Path):
    folder.mkdir(exist_ok=True, parents=True)
    for name, fig in plots.items():
        name = name + ".html"
        save_plotly(fig, folder / name)


def save_mpl(fig: matplotlib.figure.Figure, loc: Path):
    fig.savefig(str(loc))
