import logging
from decimal import Decimal

from prism_agents.agents.cst_agent_torch.cst_remote.cst_remote_interface import (
    get_market_limit_client_ids,
)
from prism_agents.api.remote_request_funcs import RemoteServerInterface

logger = logging.getLogger(__name__)
test_server_url = "http://peter-test11-server-route-a5w0-photon.apps.borealis-rnd-scc.fg.rbc.com"
_prsm = "PRSM"

"""
Hack to clear the market by submitting orders opposite to existing orders
"""


def clear_market():
    server_interface = RemoteServerInterface(server_url=test_server_url)
    market_id, limit_id = get_market_limit_client_ids(
        base_alias="pierre", server_interface=server_interface
    )
    while True:
        data = server_interface.get_market_data(symbol=_prsm)
        print(f"{len(data.bids)} bids remain. {len(data.asks)} asks remain")
        if len(data.bids) > 0:
            item = data.bids[0]
            sign = -1
        elif len(data.asks) > 0:
            item = data.asks[0]
            sign = 1
        else:
            break
        server_interface.limit_order(
            symbol=_prsm,
            client_id=limit_id,
            volume=sign * abs(item.volume),
            price=Decimal(item.price).quantize(Decimal("0.01")),
        )


if __name__ == "__main__":
    clear_market()
