import logging
from decimal import Decimal

from prism_agents.agents.cst_agent_torch.cst_consts import PAPER_CST_PARAMS
from prism_agents.agents.cst_agent_torch.cst_remote.cst_remote_core import CSTMarketParseParams
from prism_agents.agents.cst_agent_torch.cst_remote.cst_runner import CSTRunner
from prism_agents.api.remote_request_funcs import RemoteServerInterface

logger = logging.getLogger(__name__)

test_server_url = "http://peter-test9-server-route-a5w0-photon.apps.borealis-rnd-scc.fg.rbc.com"


"""
Experimental script verifying that we can connect to the prism api
and submit orders according the CST agent.
Ideally we should implement integration tests in the future.
"""


def experiment():
    runner = CSTRunner(
        params=PAPER_CST_PARAMS,
        parse_params=CSTMarketParseParams(num_ticks=25, tick_size=Decimal("0.01"), volume_unit=1),
        seed=12345678,
        alias="peter",
    )
    runner.run(
        server_interface=RemoteServerInterface(server_url=test_server_url), time_warp_factor=1.0
    )


if __name__ == "__main__":
    experiment()
