from decimal import Decimal

from prism_agents.api.remote_request_funcs import RemoteServerInterface

# test_server_url = "http://peter-test11-server-route-a5w0-photon.apps.borealis-rnd-scc.fg.rbc.com"
test_server_url = "http://10.211.190.75:1603"


def go():
    server_interface = RemoteServerInterface(server_url=test_server_url)
    user_name_1 = "test_user"
    user_name_2 = "test_user_2"
    client_id_1 = server_interface.register(user_name_1)
    client_id_2 = server_interface.register(user_name_2)
    server_interface.limit_order(
        symbol="PRSM", client_id=client_id_1, volume=1, price=Decimal("10")
    )
    server_interface.limit_order(
        symbol="PRSM", client_id=client_id_2, volume=-1, price=Decimal("10")
    )
    server_interface.limit_order(
        symbol="PRSM", client_id=client_id_1, volume=-1, price=Decimal("20")
    )
    server_interface.limit_order(
        symbol="PRSM", client_id=client_id_2, volume=1, price=Decimal("20")
    )

    client_1_data = server_interface.get_client_data(client_id_1)
    client_2_data = server_interface.get_client_data(client_id_2)
    assert client_1_data.realizedpl == 10
    assert client_2_data.realizedpl == -10


if __name__ == "__main__":
    go()
